<?php

// PhpWatchDog - monitor your services
// http://phpwatchdog.sourceforge.net/

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// Copyright (c), 2005, Paolo Conti (pconti@users.sf.net)

include("config.php");
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
        <title>PhpWatchDog <?php echo "$version$revision$build"; ?> </title>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
        <link rel="stylesheet" href="style.css" type="text/css">
        </head>

<body bgcolor="#b0c4de">
<DIV align = "center">
<H1>PhpWatchDog <?php echo"$version$revision$build";
if ($debug == 1) {
echo " - <em>debug</em>";
}
?></H1>


<table>
<tr>
        <td>

<?php

if (isset($config['Servers'])) {

    for ($i=1; ( !empty($config['Servers'][$i]['host']) ); $i++) {

	// create the log file if not exist
	$filelog = "history/".$config['Servers'][$i]['server_name']."-".$config['Servers'][$i]['host'].".log";
	if (!file_exists($filelog)) {
		$fh=@fopen("history/".$config['Servers'][$i]['server_name']."-".$config['Servers'][$i]['host'].".log","a");
		$unix_time = date("U");
		@fputs($fh,"Start monitoring on $unix_time\n");
		@fclose($fh);
	}

    echo "
         <table width=\"500\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\" bgcolor=\"#FFFFFF\" class=\"border\">
           <tr bgcolor=\"#dcdcdc\">
             <td class=\"dateline\">Host : </td>
             <td colspan=\"3\" align=\"center\"> > <a name=\"".$config['Servers'][$i]['host']."\"> ".$config['Servers'][$i]['host']." - <em>".$config['Servers'][$i]['server_name']."</em> </a> < </td>
           </tr>
           <tr class=bg_color>
             <td>&nbsp;</td>
             <td class=\"dateline\">Port</td>
             <td class=\"dateline\">Service</td>
             <td align=\"center\" class=\"dateline\">Status</td>
           </tr>
           ";

    for ($g=1; ( !empty($config['Servers'][$i]['service'][$g]) ); $g++) {

           if ($g%2==0) { $color=" class=bg_color"; } else { $color=""; }

           echo "
                  <tr$color>
                    <td>&nbsp;</td>
                    <td width=\"150\">".$config['Servers'][$i]['service'][$g]."</td>
                    <td width=\"100\">".evaluate_protocol($config['Servers'][$i]['service'][$g])."</td>
                    <td align=\"center\" width=\"150\">";

#############################################################
# Check the socket control mode *- PERL -* START
#############################################################
if ( $perl_mode == "on" ) {

	$command = ("./tools/chk_socket2.pl ".$config['Servers'][$i]['host']." ".$config['Servers'][$i]['service'][$g]." $time_out");
	$status = shell_exec("$command");

	If (ereg('up', $status))
		{
		echo "<img src='images/g_green_on.gif' width=12 height=12 alt=''/> <font color=lime face=verdana size=2><b>Running</b></font>";
		}
	else
		{

		echo "<img src='images/g_red_anim.gif' width=12 height=12 alt='g_red_anim.gif (1KB)'/> <font color=red face=verdana size=2><b>Offline</b></font>";

		// Set the RED led on the servers list
		$config['Servers'][$i]['critical'] = 'on';
		$config['Servers'][$i]['service_down'][$g] = $config['Servers'][$i]['service'][$g];

		}

#############################################################
# Check the socket control mode *- PERL -* STOP
#############################################################

} else {

#############################################################
# Check the socket control mode *- PHP -* START
#############################################################

			$fp = @fsockopen ($config['Servers'][$i]['host'], $config['Servers'][$i]['service'][$g], $errno, $errstr, $time_out);

			if (!$fp) {

				echo "<img src='images/g_red_anim.gif' width=12 height=12 alt='g_red_anim.gif (1KB)'/> <font color=red face=verdana size=2><b>Offline</b></font>";

				// Set the RED led on the servers list
				$config['Servers'][$i]['critical'] = 'on';
				$config['Servers'][$i]['service_down'][$g] = $config['Servers'][$i]['service'][$g];

			} else {
				echo "<img src='images/g_green_on.gif' width=12 height=12 alt=''/> <font color=lime face=verdana size=2><b>Running</b></font>";
			}

}
#############################################################
# Check the socket control mode *- PHP -* STOP
#############################################################

            echo
                    "</td>
                  </tr>
           ";
    }

    echo "
         </table><br>\n
    ";

      //$fp = null;
    }
}

?>

</td>
        <td valign="top">


         <table border="0" cellpadding="3" cellspacing="0" bgcolor="#FFFFFF" class="border">
          <tr bgcolor="#dcdcdc" align="center">
            <td class="dateline"> Servers List </td>
          </tr>
          <?php

#############################################################
# Drow right summary START
#############################################################

		  $i=0;
          for ($i=1; ( !empty($config['Servers'][$i]['host']) ); $i++) {

               if ($i%2==0) { $color="bgcolor=#E7F4FF"; } else { $color=""; }

               echo "<tr $color>
                      <td>";

                      if (($config['Servers'][$i]['critical'] != 'on')) { echo "<img src='images/g_green_anim.gif' width=12 height=12 alt=''/>";}
                      else {echo "<img src='images/g_red_anim.gif' width=12 height=12 alt=''/>";}


               echo " <a HREF=\"#".$config['Servers'][$i]['host']."\" title=\"IP: ".$config['Servers'][$i]['host']."\"> ".$config['Servers'][$i]['server_name']."</a> </td>
                     </tr>";
          }

############################################################
# Drow right summary STOP
#############################################################

          ?>

        </table>

        </td>
</tr>
</table>

You are viewing these stats from client ip address <?php echo $_SERVER["REMOTE_ADDR"]?>
<br>
<A href="http://phpwatchdog.sourceforge.net/">PhpWatchDog</A> Version <?php echo"$version$revision$build"; ?>

<?php
// --------------------------------- The sending email part ----------------------------------
$i=0;
echo "<hr>";
for ($i=1; ( !empty($config['Servers'][$i]['host']) ); $i++) {

	if ($config['Servers'][$i]['critical'] == "on") {

		// Reset the BODY
		$BODY="";

		reset($config['Servers'][$i]['service_down']);
		while(list($k, $v)=each($config['Servers'][$i]['service_down']))
		{
		$SUBJECT = "PhpWatchDog - found problem at > ".$config['Servers'][$i]['server_name']." < ";
		$BODY .= "The ".evaluate_protocol($config['Servers'][$i]['service'][$k])." service is not responding on your server at ".$config['Servers'][$i]['host']." !!!\n";
		$BODY .= "Service's port: ".$config['Servers'][$i]['service'][$k];
		$BODY .= "\nAlias / Resolved name: ".$config['Servers'][$i]['server_name']."\n\n";

// 		echo "$k<hr>$v<br><br><br>";
		}

		// The subject of Email for problem reporting ; disabled on debug mode
		if ($debug != 1) {
		mail("$MAILTO", "$SUBJECT", "$BODY", "$REST");
		}

		// If alternate_email for error reporting is enabled, send the email too
		if ( (isset($config['Servers'][$i]['alternate_email'])) AND ($debug != 1) ) {
			mail($config['Servers'][$i]['alternate_email'], "$SUBJECT", "$BODY", "$REST");
		}

		// generate the log file (servername-IP) into ./history directory
		if ($debug != 1) {

		if ($fh=@fopen("history/".$config['Servers'][$i]['server_name']."-".$config['Servers'][$i]['host'].".log","a")) {
			$unix_time = date("U");
			fputs($fh,"$unix_time\n");
  			fclose($fh);
		} else {
			echo "<br>Failed to create log!<br>";
		}

		}

		if ($debug == 1) {
			echo "<div align=\"left\">Email not sent! (Debug Mode On)<pre>";
			echo "<strong>MailTo:</strong> $MAILTO";
			echo "<br><strong>Subject:</strong> $SUBJECT";
			echo "<br><strong>Body:</strong> $BODY";
			echo "<br><strong>Rest:</strong> $REST";
			echo "</pre></div>";
		}

	}
}

if ($perl_mode=="on") {
echo "<br>* Perl socket check enabled *";
}
?>

</DIV>

<?php
// debug print all array config data
if ($debug == 1) {
echo 'Current PHP version: ' . phpversion();
echo "<pre>";
print_r($config);
echo "</pre>";
}
?>
<div align="center"><p>
    <a href="http://validator.w3.org/check?uri=referer"><img src="images/valid-html401.png" alt="Valid HTML 4.01 Transitional" width="88" height="31" border="0"></a>
  </p></div>
</body>
</html>
