<?php

// PhpWatchDog - monitor your services
// http://phpwatchdog.sourceforge.net/

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// Copyright (c), 2005, Paolo Conti (pconti@users.sf.net)

function evaluate_protocol($protocol_name) {

    switch ($protocol_name) {
case "1":
	$protocol_name = "tcpmux";
break;
case "2":
	$protocol_name = "compressnet";
break;
case "3":
	$protocol_name = "compressnet";
break;
case "5":
	$protocol_name = "rje";
break;
case "7":
	$protocol_name = "echo";
break;
case "9":
	$protocol_name = "discard";
break;
case "11":
	$protocol_name = "systat";
break;
case "13":
	$protocol_name = "daytime";
break;
case "15":
	$protocol_name = "netstat";
break;
case "17":
	$protocol_name = "qotd";
break;
case "18":
	$protocol_name = "msp";
break;
case "19":
	$protocol_name = "chargen";
break;
case "20":
	$protocol_name = "ftp-data";
break;
case "21":
	$protocol_name = "ftp";
break;
case "22":
	$protocol_name = "ssh";
break;
case "23":
	$protocol_name = "telnet";
break;
case "24":
	$protocol_name = "priv-mail";
break;
case "25":
	$protocol_name = "smtp";
break;
case "27":
	$protocol_name = "nsw-fe";
break;
case "29":
	$protocol_name = "msg-icp";
break;
case "31":
	$protocol_name = "msg-auth";
break;
case "33":
	$protocol_name = "dsp";
break;
case "35":
	$protocol_name = "priv-print";
break;
case "37":
	$protocol_name = "time";
break;
case "38":
	$protocol_name = "rap";
break;
case "39":
	$protocol_name = "rlp";
break;
case "41":
	$protocol_name = "graphics";
break;
case "42":
	$protocol_name = "nameserver";
break;
case "43":
	$protocol_name = "whois";
break;
case "44":
	$protocol_name = "mpm-flags";
break;
case "45":
	$protocol_name = "mpm";
break;
case "46":
	$protocol_name = "mpm-snd";
break;
case "47":
	$protocol_name = "ni-ftp";
break;
case "48":
	$protocol_name = "auditd";
break;
case "49":
	$protocol_name = "tacacs";
break;
case "50":
	$protocol_name = "re-mail-ck";
break;
case "51":
	$protocol_name = "la-maint";
break;
case "52":
	$protocol_name = "xns-time";
break;
case "53":
	$protocol_name = "domain";
break;
case "54":
	$protocol_name = "xns-ch";
break;
case "55":
	$protocol_name = "isi-gl";
break;
case "56":
	$protocol_name = "xns-auth";
break;
case "57":
	$protocol_name = "priv-term";
break;
case "58":
	$protocol_name = "xns-mail";
break;
case "59":
	$protocol_name = "priv-file";
break;
case "61":
	$protocol_name = "ni-mail";
break;
case "62":
	$protocol_name = "acas";
break;
case "63":
	$protocol_name = "via-ftp";
break;
case "64":
	$protocol_name = "covia";
break;
case "65":
	$protocol_name = "tacacs-ds";
break;
case "66":
	$protocol_name = "sql*net";
break;
case "67":
	$protocol_name = "dhcpserver";
break;
case "68":
	$protocol_name = "dhcpclient";
break;
case "69":
	$protocol_name = "tftp";
break;
case "70":
	$protocol_name = "gopher";
break;
case "71":
	$protocol_name = "netrjs-1";
break;
case "72":
	$protocol_name = "netrjs-2";
break;
case "73":
	$protocol_name = "netrjs-3";
break;
case "74":
	$protocol_name = "netrjs-4";
break;
case "75":
	$protocol_name = "priv-dial";
break;
case "76":
	$protocol_name = "deos";
break;
case "77":
	$protocol_name = "priv-rje";
break;
case "78":
	$protocol_name = "vettcp";
break;
case "79":
	$protocol_name = "finger";
break;
case "80":
	$protocol_name = "http";
break;
case "81":
	$protocol_name = "hosts2-ns";
break;
case "82":
	$protocol_name = "xfer";
break;
case "83":
	$protocol_name = "mit-ml-dev";
break;
case "84":
	$protocol_name = "ctf";
break;
case "85":
	$protocol_name = "mit-ml-dev";
break;
case "86":
	$protocol_name = "mfcobol";
break;
case "87":
	$protocol_name = "priv-term-l";
break;
case "88":
	$protocol_name = "kerberos-sec";
break;
case "89":
	$protocol_name = "su-mit-tg";
break;
case "90":
	$protocol_name = "dnsix";
break;
case "91":
	$protocol_name = "mit-dov";
break;
case "92":
	$protocol_name = "npp";
break;
case "93":
	$protocol_name = "dcp";
break;
case "94":
	$protocol_name = "objcall";
break;
case "95":
	$protocol_name = "supdup";
break;
case "96":
	$protocol_name = "dixie";
break;
case "97":
	$protocol_name = "swift-rvf";
break;
case "98":
	$protocol_name = "linuxconf";
break;
case "99":
	$protocol_name = "metagram";
break;
case "100":
	$protocol_name = "newacct";
break;
case "101":
	$protocol_name = "hostname";
break;
case "102":
	$protocol_name = "iso-tsap";
break;
case "103":
	$protocol_name = "gppitnp";
break;
case "104":
	$protocol_name = "acr-nema";
break;
case "105":
	$protocol_name = "csnet-ns";
break;
case "106":
	$protocol_name = "pop3pw";
break;
case "107":
	$protocol_name = "rtelnet";
break;
case "108":
	$protocol_name = "snagas";
break;
case "109":
	$protocol_name = "pop-2";
break;
case "110":
	$protocol_name = "pop-3";
break;
case "111":
	$protocol_name = "sunrpc";
break;
case "112":
	$protocol_name = "mcidas";
break;
case "113":
	$protocol_name = "auth";
break;
case "114":
	$protocol_name = "audionews";
break;
case "115":
	$protocol_name = "sftp";
break;
case "116":
	$protocol_name = "ansanotify";
break;
case "117":
	$protocol_name = "uucp-path";
break;
case "118":
	$protocol_name = "sqlserv";
break;
case "119":
	$protocol_name = "nntp";
break;
case "120":
	$protocol_name = "cfdptkt";
break;
case "121":
	$protocol_name = "erpc";
break;
case "122":
	$protocol_name = "smakynet";
break;
case "123":
	$protocol_name = "ntp";
break;
case "124":
	$protocol_name = "ansatrader";
break;
case "125":
	$protocol_name = "locus-map";
break;
case "126":
	$protocol_name = "unitary";
break;
case "127":
	$protocol_name = "locus-con";
break;
case "128":
	$protocol_name = "gss-xlicen";
break;
case "129":
	$protocol_name = "pwdgen";
break;
case "130":
	$protocol_name = "cisco-fna";
break;
case "131":
	$protocol_name = "cisco-tna";
break;
case "132":
	$protocol_name = "cisco-sys";
break;
case "133":
	$protocol_name = "statsrv";
break;
case "134":
	$protocol_name = "ingres-net";
break;
case "135":
	$protocol_name = "loc-srv";
break;
case "136":
	$protocol_name = "profile";
break;
case "137":
	$protocol_name = "netbios-ns";
break;
case "138":
	$protocol_name = "netbios-dgm";
break;
case "139":
	$protocol_name = "netbios-ssn";
break;
case "140":
	$protocol_name = "emfis-data";
break;
case "141":
	$protocol_name = "emfis-cntl";
break;
case "142":
	$protocol_name = "bl-idm";
break;
case "143":
	$protocol_name = "imap2";
break;
case "144":
	$protocol_name = "news";
break;
case "145":
	$protocol_name = "uaac";
break;
case "146":
	$protocol_name = "iso-tp0";
break;
case "147":
	$protocol_name = "iso-ip";
break;
case "148":
	$protocol_name = "cronus";
break;
case "149":
	$protocol_name = "aed-512";
break;
case "150":
	$protocol_name = "sql-net";
break;
case "151":
	$protocol_name = "hems";
break;
case "152":
	$protocol_name = "bftp";
break;
case "153":
	$protocol_name = "sgmp";
break;
case "154":
	$protocol_name = "netsc-prod";
break;
case "155":
	$protocol_name = "netsc-dev";
break;
case "156":
	$protocol_name = "sqlsrv";
break;
case "157":
	$protocol_name = "knet-cmp";
break;
case "158":
	$protocol_name = "pcmail-srv";
break;
case "159":
	$protocol_name = "nss-routing";
break;
case "160":
	$protocol_name = "sgmp-traps";
break;
case "161":
	$protocol_name = "snmp";
break;
case "162":
	$protocol_name = "snmptrap";
break;
case "163":
	$protocol_name = "cmip-man";
break;
case "164":
	$protocol_name = "cmip-agent";
break;
case "165":
	$protocol_name = "xns-courier";
break;
case "166":
	$protocol_name = "s-net";
break;
case "167":
	$protocol_name = "namp";
break;
case "168":
	$protocol_name = "rsvd";
break;
case "169":
	$protocol_name = "send";
break;
case "170":
	$protocol_name = "print-srv";
break;
case "171":
	$protocol_name = "multiplex";
break;
case "172":
	$protocol_name = "cl-1";
break;
case "173":
	$protocol_name = "xyplex-mux";
break;
case "174":
	$protocol_name = "mailq";
break;
case "175":
	$protocol_name = "vmnet";
break;
case "176":
	$protocol_name = "genrad-mux";
break;
case "177":
	$protocol_name = "xdmcp";
break;
case "178":
	$protocol_name = "nextstep";
break;
case "179":
	$protocol_name = "bgp";
break;
case "180":
	$protocol_name = "ris";
break;
case "181":
	$protocol_name = "unify";
break;
case "182":
	$protocol_name = "audit";
break;
case "183":
	$protocol_name = "ocbinder";
break;
case "184":
	$protocol_name = "ocserver";
break;
case "185":
	$protocol_name = "remote-kis";
break;
case "186":
	$protocol_name = "kis";
break;
case "187":
	$protocol_name = "aci";
break;
case "188":
	$protocol_name = "mumps";
break;
case "189":
	$protocol_name = "qft";
break;
case "190":
	$protocol_name = "gacp";
break;
case "191":
	$protocol_name = "prospero";
break;
case "192":
	$protocol_name = "osu-nms";
break;
case "193":
	$protocol_name = "srmp";
break;
case "194":
	$protocol_name = "irc";
break;
case "195":
	$protocol_name = "dn6-nlm-aud";
break;
case "196":
	$protocol_name = "dn6-smm-red";
break;
case "197":
	$protocol_name = "dls";
break;
case "198":
	$protocol_name = "dls-mon";
break;
case "199":
	$protocol_name = "smux";
break;
case "200":
	$protocol_name = "src";
break;
case "201":
	$protocol_name = "at-rtmp";
break;
case "202":
	$protocol_name = "at-nbp";
break;
case "203":
	$protocol_name = "at-3";
break;
case "204":
	$protocol_name = "at-echo";
break;
case "205":
	$protocol_name = "at-5";
break;
case "206":
	$protocol_name = "at-zis";
break;
case "207":
	$protocol_name = "at-7";
break;
case "208":
	$protocol_name = "at-8";
break;
case "209":
	$protocol_name = "tam";
break;
case "210":
	$protocol_name = "z39.50";
break;
case "211":
	$protocol_name = "914c-g";
break;
case "212":
	$protocol_name = "anet";
break;
case "213":
	$protocol_name = "ipx";
break;
case "214":
	$protocol_name = "vmpwscs";
break;
case "215":
	$protocol_name = "softpc";
break;
case "216":
	$protocol_name = "atls";
break;
case "217":
	$protocol_name = "dbase";
break;
case "218":
	$protocol_name = "mpp";
break;
case "219":
	$protocol_name = "uarps";
break;
case "220":
	$protocol_name = "imap3";
break;
case "221":
	$protocol_name = "fln-spx";
break;
case "222":
	$protocol_name = "rsh-spx";
break;
case "223":
	$protocol_name = "cdc";
break;
case "242":
	$protocol_name = "direct";
break;
case "243":
	$protocol_name = "sur-meas";
break;
case "244":
	$protocol_name = "dayna";
break;
case "245":
	$protocol_name = "link";
break;
case "246":
	$protocol_name = "dsp3270";
break;
case "247":
	$protocol_name = "subntbcst_tftp";
break;
case "248":
	$protocol_name = "bhfhs";
break;
case "256":
	$protocol_name = "FW1-secureremote";
break;
case "257":
	$protocol_name = "FW1-mc-fwmodule";
break;
case "258":
	$protocol_name = "Fw1-mc-gui";
break;
case "259":
	$protocol_name = "esro-gen";
break;
case "260":
	$protocol_name = "openport";
break;
case "261":
	$protocol_name = "nsiiops";
break;
case "262":
	$protocol_name = "arcisdms";
break;
case "263":
	$protocol_name = "hdap";
break;
case "264":
	$protocol_name = "bgmp";
break;
case "265":
	$protocol_name = "maybeFW1";
break;
case "280":
	$protocol_name = "http-mgmt";
break;
case "281":
	$protocol_name = "personal-link";
break;
case "282":
	$protocol_name = "cableport-ax";
break;
case "308":
	$protocol_name = "novastorbakcup";
break;
case "309":
	$protocol_name = "entrusttime";
break;
case "310":
	$protocol_name = "bhmds";
break;
case "311":
	$protocol_name = "asip-webadmin";
break;
case "312":
	$protocol_name = "vslmp";
break;
case "313":
	$protocol_name = "magenta-logic";
break;
case "314":
	$protocol_name = "opalis-robot";
break;
case "315":
	$protocol_name = "dpsi";
break;
case "316":
	$protocol_name = "decauth";
break;
case "317":
	$protocol_name = "zannet";
break;
case "321":
	$protocol_name = "pip";
break;
case "344":
	$protocol_name = "pdap";
break;
case "345":
	$protocol_name = "pawserv";
break;
case "346":
	$protocol_name = "zserv";
break;
case "347":
	$protocol_name = "fatserv";
break;
case "348":
	$protocol_name = "csi-sgwp";
break;
case "349":
	$protocol_name = "mftp";
break;
case "350":
	$protocol_name = "matip-type-a";
break;
case "351":
	$protocol_name = "matip-type-b";
break;
case "352":
	$protocol_name = "dtag-ste-sb";
break;
case "353":
	$protocol_name = "ndsauth";
break;
case "354":
	$protocol_name = "bh611";
break;
case "355":
	$protocol_name = "datex-asn";
break;
case "356":
	$protocol_name = "cloanto-net-1";
break;
case "357":
	$protocol_name = "bhevent";
break;
case "358":
	$protocol_name = "shrinkwrap";
break;
case "359":
	$protocol_name = "tenebris_nts";
break;
case "360":
	$protocol_name = "scoi2odialog";
break;
case "361":
	$protocol_name = "semantix";
break;
case "362":
	$protocol_name = "srssend";
break;
case "363":
	$protocol_name = "rsvp_tunnel";
break;
case "364":
	$protocol_name = "aurora-cmgr";
break;
case "365":
	$protocol_name = "dtk";
break;
case "366":
	$protocol_name = "odmr";
break;
case "367":
	$protocol_name = "mortgageware";
break;
case "368":
	$protocol_name = "qbikgdp";
break;
case "369":
	$protocol_name = "rpc2portmap";
break;
case "370":
	$protocol_name = "codaauth2";
break;
case "371":
	$protocol_name = "clearcase";
break;
case "372":
	$protocol_name = "ulistserv";
break;
case "373":
	$protocol_name = "legent-1";
break;
case "374":
	$protocol_name = "legent-2";
break;
case "375":
	$protocol_name = "hassle";
break;
case "376":
	$protocol_name = "nip";
break;
case "377":
	$protocol_name = "tnETOS";
break;
case "378":
	$protocol_name = "dsETOS";
break;
case "379":
	$protocol_name = "is99c";
break;
case "380":
	$protocol_name = "is99s";
break;
case "381":
	$protocol_name = "hp-collector";
break;
case "382":
	$protocol_name = "hp-managed-node";
break;
case "383":
	$protocol_name = "hp-alarm-mgr";
break;
case "384":
	$protocol_name = "arns";
break;
case "385":
	$protocol_name = "ibm-app";
break;
case "386":
	$protocol_name = "asa";
break;
case "387":
	$protocol_name = "aurp";
break;
case "388":
	$protocol_name = "unidata-ldm";
break;
case "389":
	$protocol_name = "ldap";
break;
case "390":
	$protocol_name = "uis";
break;
case "391":
	$protocol_name = "synotics-relay";
break;
case "392":
	$protocol_name = "synotics-broker";
break;
case "393":
	$protocol_name = "dis";
break;
case "394":
	$protocol_name = "embl-ndt";
break;
case "395":
	$protocol_name = "netcp";
break;
case "396":
	$protocol_name = "netware-ip";
break;
case "397":
	$protocol_name = "mptn";
break;
case "398":
	$protocol_name = "kryptolan";
break;
case "399":
	$protocol_name = "iso-tsap-c2";
break;
case "400":
	$protocol_name = "work-sol";
break;
case "401":
	$protocol_name = "ups";
break;
case "402":
	$protocol_name = "genie";
break;
case "403":
	$protocol_name = "decap";
break;
case "404":
	$protocol_name = "nced";
break;
case "405":
	$protocol_name = "ncld";
break;
case "406":
	$protocol_name = "imsp";
break;
case "407":
	$protocol_name = "timbuktu";
break;
case "408":
	$protocol_name = "prm-sm";
break;
case "409":
	$protocol_name = "prm-nm";
break;
case "410":
	$protocol_name = "decladebug";
break;
case "411":
	$protocol_name = "rmt";
break;
case "412":
	$protocol_name = "synoptics-trap";
break;
case "413":
	$protocol_name = "smsp";
break;
case "414":
	$protocol_name = "infoseek";
break;
case "415":
	$protocol_name = "bnet";
break;
case "416":
	$protocol_name = "silverplatter";
break;
case "417":
	$protocol_name = "onmux";
break;
case "418":
	$protocol_name = "hyper-g";
break;
case "419":
	$protocol_name = "ariel1";
break;
case "420":
	$protocol_name = "smpte";
break;
case "421":
	$protocol_name = "ariel2";
break;
case "422":
	$protocol_name = "ariel3";
break;
case "423":
	$protocol_name = "opc-job-start";
break;
case "424":
	$protocol_name = "opc-job-track";
break;
case "425":
	$protocol_name = "icad-el";
break;
case "426":
	$protocol_name = "smartsdp";
break;
case "427":
	$protocol_name = "svrloc";
break;
case "428":
	$protocol_name = "ocs_cmu";
break;
case "429":
	$protocol_name = "ocs_amu";
break;
case "430":
	$protocol_name = "utmpsd";
break;
case "431":
	$protocol_name = "utmpcd";
break;
case "432":
	$protocol_name = "iasd";
break;
case "433":
	$protocol_name = "nnsp";
break;
case "434":
	$protocol_name = "mobileip-agent";
break;
case "435":
	$protocol_name = "mobilip-mn";
break;
case "436":
	$protocol_name = "dna-cml";
break;
case "437":
	$protocol_name = "comscm";
break;
case "438":
	$protocol_name = "dsfgw";
break;
case "439":
	$protocol_name = "dasp";
break;
case "440":
	$protocol_name = "sgcp";
break;
case "441":
	$protocol_name = "decvms-sysmgt";
break;
case "442":
	$protocol_name = "cvc_hostd";
break;
case "443":
	$protocol_name = "https";
break;
case "444":
	$protocol_name = "snpp";
break;
case "445":
	$protocol_name = "microsoft-ds";
break;
case "446":
	$protocol_name = "ddm-rdb";
break;
case "447":
	$protocol_name = "ddm-dfm";
break;
case "448":
	$protocol_name = "ddm-ssl";
break;
case "449":
	$protocol_name = "as-servermap";
break;
case "450":
	$protocol_name = "tserver";
break;
case "451":
	$protocol_name = "sfs-smp-net";
break;
case "452":
	$protocol_name = "sfs-config";
break;
case "453":
	$protocol_name = "creativeserver";
break;
case "454":
	$protocol_name = "contentserver";
break;
case "455":
	$protocol_name = "creativepartnr";
break;
case "456":
	$protocol_name = "macon-tcp";
break;
case "457":
	$protocol_name = "scohelp";
break;
case "458":
	$protocol_name = "appleqtc";
break;
case "459":
	$protocol_name = "ampr-rcmd";
break;
case "460":
	$protocol_name = "skronk";
break;
case "461":
	$protocol_name = "datasurfsrv";
break;
case "462":
	$protocol_name = "datasurfsrvsec";
break;
case "463":
	$protocol_name = "alpes";
break;
case "464":
	$protocol_name = "kpasswd5";
break;
case "465":
	$protocol_name = "smtps";
break;
case "466":
	$protocol_name = "digital-vrc";
break;
case "467":
	$protocol_name = "mylex-mapd";
break;
case "468":
	$protocol_name = "photuris";
break;
case "469":
	$protocol_name = "rcp";
break;
case "470":
	$protocol_name = "scx-proxy";
break;
case "471":
	$protocol_name = "mondex";
break;
case "472":
	$protocol_name = "ljk-login";
break;
case "473":
	$protocol_name = "hybrid-pop";
break;
case "474":
	$protocol_name = "tn-tl-w1";
break;
case "475":
	$protocol_name = "tcpnethaspsrv";
break;
case "476":
	$protocol_name = "tn-tl-fd1";
break;
case "477":
	$protocol_name = "ss7ns";
break;
case "478":
	$protocol_name = "spsc";
break;
case "479":
	$protocol_name = "iafserver";
break;
case "480":
	$protocol_name = "loadsrv";
break;
case "481":
	$protocol_name = "dvs";
break;
case "482":
	$protocol_name = "bgs-nsi";
break;
case "483":
	$protocol_name = "ulpnet";
break;
case "484":
	$protocol_name = "integra-sme";
break;
case "485":
	$protocol_name = "powerburst";
break;
case "486":
	$protocol_name = "sstats";
break;
case "487":
	$protocol_name = "saft";
break;
case "488":
	$protocol_name = "gss-http";
break;
case "489":
	$protocol_name = "nest-protocol";
break;
case "490":
	$protocol_name = "micom-pfs";
break;
case "491":
	$protocol_name = "go-login";
break;
case "492":
	$protocol_name = "ticf-1";
break;
case "493":
	$protocol_name = "ticf-2";
break;
case "494":
	$protocol_name = "pov-ray";
break;
case "495":
	$protocol_name = "intecourier";
break;
case "496":
	$protocol_name = "pim-rp-disc";
break;
case "497":
	$protocol_name = "dantz";
break;
case "498":
	$protocol_name = "siam";
break;
case "499":
	$protocol_name = "iso-ill";
break;
case "500":
	$protocol_name = "isakmp";
break;
case "501":
	$protocol_name = "stmf";
break;
case "502":
	$protocol_name = "asa-appl-proto";
break;
case "503":
	$protocol_name = "intrinsa";
break;
case "504":
	$protocol_name = "citadel";
break;
case "505":
	$protocol_name = "mailbox-lm";
break;
case "506":
	$protocol_name = "ohimsrv";
break;
case "507":
	$protocol_name = "crs";
break;
case "508":
	$protocol_name = "xvttp";
break;
case "509":
	$protocol_name = "snare";
break;
case "510":
	$protocol_name = "fcp";
break;
case "511":
	$protocol_name = "passgo";
break;
case "512":
	$protocol_name = "exec";
break;
case "513":
	$protocol_name = "login";
break;
case "514":
	$protocol_name = "shell";
break;
case "515":
	$protocol_name = "printer";
break;
case "516":
	$protocol_name = "videotex";
break;
case "517":
	$protocol_name = "talk";
break;
case "518":
	$protocol_name = "ntalk";
break;
case "519":
	$protocol_name = "utime";
break;
case "520":
	$protocol_name = "efs";
break;
case "521":
	$protocol_name = "ripng";
break;
case "522":
	$protocol_name = "ulp";
break;
case "523":
	$protocol_name = "ibm-db2";
break;
case "524":
	$protocol_name = "ncp";
break;
case "525":
	$protocol_name = "timed";
break;
case "526":
	$protocol_name = "tempo";
break;
case "527":
	$protocol_name = "stx";
break;
case "528":
	$protocol_name = "custix";
break;
case "529":
	$protocol_name = "irc-serv";
break;
case "530":
	$protocol_name = "courier";
break;
case "531":
	$protocol_name = "conference";
break;
case "532":
	$protocol_name = "netnews";
break;
case "533":
	$protocol_name = "netwall";
break;
case "534":
	$protocol_name = "mm-admin";
break;
case "535":
	$protocol_name = "iiop";
break;
case "536":
	$protocol_name = "opalis-rdv";
break;
case "537":
	$protocol_name = "nmsp";
break;
case "538":
	$protocol_name = "gdomap";
break;
case "539":
	$protocol_name = "apertus-ldp";
break;
case "540":
	$protocol_name = "uucp";
break;
case "541":
	$protocol_name = "uucp-rlogin";
break;
case "542":
	$protocol_name = "commerce";
break;
case "543":
	$protocol_name = "klogin";
break;
case "544":
	$protocol_name = "kshell";
break;
case "545":
	$protocol_name = "ekshell";
break;
case "546":
	$protocol_name = "dhcpv6-client";
break;
case "547":
	$protocol_name = "dhcpv6-server";
break;
case "548":
	$protocol_name = "afpovertcp";
break;
case "549":
	$protocol_name = "idfp";
break;
case "550":
	$protocol_name = "new-rwho";
break;
case "551":
	$protocol_name = "cybercash";
break;
case "552":
	$protocol_name = "deviceshare";
break;
case "553":
	$protocol_name = "pirp";
break;
case "554":
	$protocol_name = "rtsp";
break;
case "555":
	$protocol_name = "dsf";
break;
case "556":
	$protocol_name = "remotefs";
break;
case "557":
	$protocol_name = "openvms-sysipc";
break;
case "558":
	$protocol_name = "sdnskmp";
break;
case "559":
	$protocol_name = "teedtap";
break;
case "560":
	$protocol_name = "rmonitor";
break;
case "561":
	$protocol_name = "monitor";
break;
case "562":
	$protocol_name = "chshell";
break;
case "563":
	$protocol_name = "snews";
break;
case "564":
	$protocol_name = "9pfs";
break;
case "565":
	$protocol_name = "whoami";
break;
case "566":
	$protocol_name = "streettalk";
break;
case "567":
	$protocol_name = "banyan-rpc";
break;
case "568":
	$protocol_name = "ms-shuttle";
break;
case "569":
	$protocol_name = "ms-rome";
break;
case "570":
	$protocol_name = "meter";
break;
case "571":
	$protocol_name = "umeter";
break;
case "572":
	$protocol_name = "sonar";
break;
case "573":
	$protocol_name = "banyan-vip";
break;
case "574":
	$protocol_name = "ftp-agent";
break;
case "575":
	$protocol_name = "vemmi";
break;
case "576":
	$protocol_name = "ipcd";
break;
case "577":
	$protocol_name = "vnas";
break;
case "578":
	$protocol_name = "ipdd";
break;
case "579":
	$protocol_name = "decbsrv";
break;
case "580":
	$protocol_name = "sntp-heartbeat";
break;
case "581":
	$protocol_name = "bdp";
break;
case "582":
	$protocol_name = "scc-security";
break;
case "583":
	$protocol_name = "philips-vc";
break;
case "584":
	$protocol_name = "keyserver";
break;
case "585":
	$protocol_name = "imap4-ssl";
break;
case "586":
	$protocol_name = "password-chg";
break;
case "587":
	$protocol_name = "submission";
break;
case "588":
	$protocol_name = "cal";
break;
case "589":
	$protocol_name = "eyelink";
break;
case "590":
	$protocol_name = "tns-cml";
break;
case "591":
	$protocol_name = "http-alt";
break;
case "592":
	$protocol_name = "eudora-set";
break;
case "593":
	$protocol_name = "http-rpc-epmap";
break;
case "594":
	$protocol_name = "tpip";
break;
case "595":
	$protocol_name = "cab-protocol";
break;
case "596":
	$protocol_name = "smsd";
break;
case "597":
	$protocol_name = "ptcnameservice";
break;
case "598":
	$protocol_name = "sco-websrvrmg3";
break;
case "599":
	$protocol_name = "acp";
break;
case "600":
	$protocol_name = "ipcserver";
break;
case "606":
	$protocol_name = "urm";
break;
case "607":
	$protocol_name = "nqs";
break;
case "608":
	$protocol_name = "sift-uft";
break;
case "609":
	$protocol_name = "npmp-trap";
break;
case "610":
	$protocol_name = "npmp-local";
break;
case "611":
	$protocol_name = "npmp-gui";
break;
case "617":
	$protocol_name = "sco-dtmgr";
break;
case "628":
	$protocol_name = "qmqp";
break;
case "631":
	$protocol_name = "ipp";
break;
case "634":
	$protocol_name = "ginad";
break;
case "636":
	$protocol_name = "ldapssl";
break;
case "637":
	$protocol_name = "lanserver";
break;
case "660":
	$protocol_name = "mac-srvr-admin";
break;
case "666":
	$protocol_name = "doom";
break;
case "674":
	$protocol_name = "acap";
break;
case "691":
	$protocol_name = "resvc";
break;
case "704":
	$protocol_name = "elcsd";
break;
case "706":
	$protocol_name = "silc";
break;
case "709":
	$protocol_name = "entrustmanager";
break;
case "729":
	$protocol_name = "netviewdm1";
break;
case "730":
	$protocol_name = "netviewdm2";
break;
case "731":
	$protocol_name = "netviewdm3";
break;
case "740":
	$protocol_name = "netcp";
break;
case "741":
	$protocol_name = "netgw";
break;
case "742":
	$protocol_name = "netrcs";
break;
case "744":
	$protocol_name = "flexlm";
break;
case "747":
	$protocol_name = "fujitsu-dev";
break;
case "748":
	$protocol_name = "ris-cm";
break;
case "749":
	$protocol_name = "kerberos-adm";
break;
case "750":
	$protocol_name = "kerberos";
break;
case "751":
	$protocol_name = "kerberos_master";
break;
case "752":
	$protocol_name = "qrh";
break;
case "753":
	$protocol_name = "rrh";
break;
case "754":
	$protocol_name = "krb_prop";
break;
case "758":
	$protocol_name = "nlogin";
break;
case "759":
	$protocol_name = "con";
break;
case "760":
	$protocol_name = "krbupdate";
break;
case "761":
	$protocol_name = "kpasswd";
break;
case "762":
	$protocol_name = "quotad";
break;
case "763":
	$protocol_name = "cycleserv";
break;
case "764":
	$protocol_name = "omserv";
break;
case "765":
	$protocol_name = "webster";
break;
case "767":
	$protocol_name = "phonebook";
break;
case "769":
	$protocol_name = "vid";
break;
case "770":
	$protocol_name = "cadlock";
break;
case "771":
	$protocol_name = "rtip";
break;
case "772":
	$protocol_name = "cycleserv2";
break;
case "773":
	$protocol_name = "submit";
break;
case "774":
	$protocol_name = "rpasswd";
break;
case "775":
	$protocol_name = "entomb";
break;
case "776":
	$protocol_name = "wpages";
break;
case "780":
	$protocol_name = "wpgs";
break;
case "781":
	$protocol_name = "hp-collector";
break;
case "782":
	$protocol_name = "hp-managed-node";
break;
case "783":
	$protocol_name = "hp-alarm-mgr";
break;
case "786":
	$protocol_name = "concert";
break;
case "799":
	$protocol_name = "controlit";
break;
case "800":
	$protocol_name = "mdbs_daemon";
break;
case "801":
	$protocol_name = "device";
break;
case "871":
	$protocol_name = "supfilesrv";
break;
case "873":
	$protocol_name = "rsync";
break;
case "888":
	$protocol_name = "accessbuilder";
break;
case "898":
	$protocol_name = "sun-manageconsole";
break;
case "989":
	$protocol_name = "ftps-data";
break;
case "901":
	$protocol_name = "samba-swat";
break;
case "950":
	$protocol_name = "oftep-rpc";
break;
case "953":
	$protocol_name = "rndc";
break;
case "975":
	$protocol_name = "securenetpro-sensor";
break;
case "990":
	$protocol_name = "ftps";
break;
case "992":
	$protocol_name = "telnets";
break;
case "993":
	$protocol_name = "imaps";
break;
case "994":
	$protocol_name = "ircs";
break;
case "995":
	$protocol_name = "pop3s";
break;
case "996":
	$protocol_name = "xtreelic";
break;
case "997":
	$protocol_name = "maitrd";
break;
case "998":
	$protocol_name = "busboy";
break;
case "999":
	$protocol_name = "garcon";
break;
case "1000":
	$protocol_name = "cadlock";
break;
case "1008":
	$protocol_name = "ufsd";
break;
case "1023":
	$protocol_name = "netvenuechat";
break;
case "1024":
	$protocol_name = "kdm";
break;
case "1025":
	$protocol_name = "NFS-or-IIS";
break;
case "1026":
	$protocol_name = "LSA-or-nterm";
break;
case "1027":
	$protocol_name = "IIS";
break;
case "1029":
	$protocol_name = "ms-lsa";
break;
case "1030":
	$protocol_name = "iad1";
break;
case "1031":
	$protocol_name = "iad2";
break;
case "1032":
	$protocol_name = "iad3";
break;
case "1033":
	$protocol_name = "netinfo";
break;
case "1050":
	$protocol_name = "java-or-OTGfileshare";
break;
case "1058":
	$protocol_name = "nim";
break;
case "1059":
	$protocol_name = "nimreg";
break;
case "1067":
	$protocol_name = "instl_boots";
break;
case "1068":
	$protocol_name = "instl_bootc";
break;
case "1076":
	$protocol_name = "sns_credit";
break;
case "1080":
	$protocol_name = "socks";
break;
case "1083":
	$protocol_name = "ansoft-lm-1";
break;
case "1084":
	$protocol_name = "ansoft-lm-2";
break;
case "1103":
	$protocol_name = "xaudio";
break;
case "1109":
	$protocol_name = "kpop";
break;
case "1110":
	$protocol_name = "nfsd-status";
break;
case "1112":
	$protocol_name = "msql";
break;
case "1127":
	$protocol_name = "supfiledbg";
break;
case "1139":
	$protocol_name = "cce3x";
break;
case "1155":
	$protocol_name = "nfa";
break;
case "1178":
	$protocol_name = "skkserv";
break;
case "1212":
	$protocol_name = "lupa";
break;
case "1220":
	$protocol_name = "quicktime";
break;
case "1222":
	$protocol_name = "nerv";
break;
case "1234":
	$protocol_name = "hotline";
break;
case "1241":
	$protocol_name = "msg";
break;
case "1248":
	$protocol_name = "hermes";
break;
case "1337":
	$protocol_name = "waste";
break;
case "1346":
	$protocol_name = "alta-ana-lm";
break;
case "1347":
	$protocol_name = "bbn-mmc";
break;
case "1348":
	$protocol_name = "bbn-mmx";
break;
case "1349":
	$protocol_name = "sbook";
break;
case "1350":
	$protocol_name = "editbench";
break;
case "1351":
	$protocol_name = "equationbuilder";
break;
case "1352":
	$protocol_name = "lotusnotes";
break;
case "1353":
	$protocol_name = "relief";
break;
case "1354":
	$protocol_name = "rightbrain";
break;
case "1355":
	$protocol_name = "intuitive-edge";
break;
case "1356":
	$protocol_name = "cuillamartin";
break;
case "1357":
	$protocol_name = "pegboard";
break;
case "1358":
	$protocol_name = "connlcli";
break;
case "1359":
	$protocol_name = "ftsrv";
break;
case "1360":
	$protocol_name = "mimer";
break;
case "1361":
	$protocol_name = "linx";
break;
case "1362":
	$protocol_name = "timeflies";
break;
case "1363":
	$protocol_name = "ndm-requester";
break;
case "1364":
	$protocol_name = "ndm-server";
break;
case "1365":
	$protocol_name = "adapt-sna";
break;
case "1366":
	$protocol_name = "netware-csp";
break;
case "1367":
	$protocol_name = "dcs";
break;
case "1368":
	$protocol_name = "screencast";
break;
case "1369":
	$protocol_name = "gv-us";
break;
case "1370":
	$protocol_name = "us-gv";
break;
case "1371":
	$protocol_name = "fc-cli";
break;
case "1372":
	$protocol_name = "fc-ser";
break;
case "1373":
	$protocol_name = "chromagrafx";
break;
case "1374":
	$protocol_name = "molly";
break;
case "1375":
	$protocol_name = "bytex";
break;
case "1376":
	$protocol_name = "ibm-pps";
break;
case "1377":
	$protocol_name = "cichlid";
break;
case "1378":
	$protocol_name = "elan";
break;
case "1379":
	$protocol_name = "dbreporter";
break;
case "1380":
	$protocol_name = "telesis-licman";
break;
case "1381":
	$protocol_name = "apple-licman";
break;
case "1383":
	$protocol_name = "gwha";
break;
case "1384":
	$protocol_name = "os-licman";
break;
case "1385":
	$protocol_name = "atex_elmd";
break;
case "1386":
	$protocol_name = "checksum";
break;
case "1387":
	$protocol_name = "cadsi-lm";
break;
case "1388":
	$protocol_name = "objective-dbc";
break;
case "1389":
	$protocol_name = "iclpv-dm";
break;
case "1390":
	$protocol_name = "iclpv-sc";
break;
case "1391":
	$protocol_name = "iclpv-sas";
break;
case "1392":
	$protocol_name = "iclpv-pm";
break;
case "1393":
	$protocol_name = "iclpv-nls";
break;
case "1394":
	$protocol_name = "iclpv-nlc";
break;
case "1395":
	$protocol_name = "iclpv-wsm";
break;
case "1396":
	$protocol_name = "dvl-activemail";
break;
case "1397":
	$protocol_name = "audio-activmail";
break;
case "1398":
	$protocol_name = "video-activmail";
break;
case "1399":
	$protocol_name = "cadkey-licman";
break;
case "1400":
	$protocol_name = "cadkey-tablet";
break;
case "1401":
	$protocol_name = "goldleaf-licman";
break;
case "1402":
	$protocol_name = "prm-sm-np";
break;
case "1403":
	$protocol_name = "prm-nm-np";
break;
case "1404":
	$protocol_name = "igi-lm";
break;
case "1405":
	$protocol_name = "ibm-res";
break;
case "1406":
	$protocol_name = "netlabs-lm";
break;
case "1407":
	$protocol_name = "dbsa-lm";
break;
case "1408":
	$protocol_name = "sophia-lm";
break;
case "1409":
	$protocol_name = "here-lm";
break;
case "1410":
	$protocol_name = "hiq";
break;
case "1411":
	$protocol_name = "af";
break;
case "1412":
	$protocol_name = "innosys";
break;
case "1413":
	$protocol_name = "innosys-acl";
break;
case "1414":
	$protocol_name = "ibm-mqseries";
break;
case "1415":
	$protocol_name = "dbstar";
break;
case "1416":
	$protocol_name = "novell-lu6.2";
break;
case "1417":
	$protocol_name = "timbuktu-srv1";
break;
case "1418":
	$protocol_name = "timbuktu-srv2";
break;
case "1419":
	$protocol_name = "timbuktu-srv3";
break;
case "1420":
	$protocol_name = "timbuktu-srv4";
break;
case "1421":
	$protocol_name = "gandalf-lm";
break;
case "1422":
	$protocol_name = "autodesk-lm";
break;
case "1423":
	$protocol_name = "essbase";
break;
case "1424":
	$protocol_name = "hybrid";
break;
case "1425":
	$protocol_name = "zion-lm";
break;
case "1426":
	$protocol_name = "sas-1";
break;
case "1427":
	$protocol_name = "mloadd";
break;
case "1428":
	$protocol_name = "informatik-lm";
break;
case "1429":
	$protocol_name = "nms";
break;
case "1430":
	$protocol_name = "tpdu";
break;
case "1431":
	$protocol_name = "rgtp";
break;
case "1432":
	$protocol_name = "blueberry-lm";
break;
case "1433":
	$protocol_name = "ms-sql-s";
break;
case "1434":
	$protocol_name = "ms-sql-m";
break;
case "1435":
	$protocol_name = "ibm-cics";
break;
case "1436":
	$protocol_name = "sas-2";
break;
case "1437":
	$protocol_name = "tabula";
break;
case "1438":
	$protocol_name = "eicon-server";
break;
case "1439":
	$protocol_name = "eicon-x25";
break;
case "1440":
	$protocol_name = "eicon-slp";
break;
case "1441":
	$protocol_name = "cadis-1";
break;
case "1442":
	$protocol_name = "cadis-2";
break;
case "1443":
	$protocol_name = "ies-lm";
break;
case "1444":
	$protocol_name = "marcam-lm";
break;
case "1445":
	$protocol_name = "proxima-lm";
break;
case "1446":
	$protocol_name = "ora-lm";
break;
case "1447":
	$protocol_name = "apri-lm";
break;
case "1448":
	$protocol_name = "oc-lm";
break;
case "1449":
	$protocol_name = "peport";
break;
case "1450":
	$protocol_name = "dwf";
break;
case "1451":
	$protocol_name = "infoman";
break;
case "1452":
	$protocol_name = "gtegsc-lm";
break;
case "1453":
	$protocol_name = "genie-lm";
break;
case "1454":
	$protocol_name = "interhdl_elmd";
break;
case "1455":
	$protocol_name = "esl-lm";
break;
case "1456":
	$protocol_name = "dca";
break;
case "1457":
	$protocol_name = "valisys-lm";
break;
case "1458":
	$protocol_name = "nrcabq-lm";
break;
case "1459":
	$protocol_name = "proshare1";
break;
case "1460":
	$protocol_name = "proshare2";
break;
case "1461":
	$protocol_name = "ibm_wrless_lan";
break;
case "1462":
	$protocol_name = "world-lm";
break;
case "1463":
	$protocol_name = "nucleus";
break;
case "1464":
	$protocol_name = "msl_lmd";
break;
case "1465":
	$protocol_name = "pipes";
break;
case "1466":
	$protocol_name = "oceansoft-lm";
break;
case "1467":
	$protocol_name = "csdmbase";
break;
case "1468":
	$protocol_name = "csdm";
break;
case "1469":
	$protocol_name = "aal-lm";
break;
case "1470":
	$protocol_name = "uaiact";
break;
case "1471":
	$protocol_name = "csdmbase";
break;
case "1472":
	$protocol_name = "csdm";
break;
case "1473":
	$protocol_name = "openmath";
break;
case "1474":
	$protocol_name = "telefinder";
break;
case "1475":
	$protocol_name = "taligent-lm";
break;
case "1476":
	$protocol_name = "clvm-cfg";
break;
case "1477":
	$protocol_name = "ms-sna-server";
break;
case "1478":
	$protocol_name = "ms-sna-base";
break;
case "1479":
	$protocol_name = "dberegister";
break;
case "1480":
	$protocol_name = "pacerforum";
break;
case "1481":
	$protocol_name = "airs";
break;
case "1482":
	$protocol_name = "miteksys-lm";
break;
case "1483":
	$protocol_name = "afs";
break;
case "1484":
	$protocol_name = "confluent";
break;
case "1485":
	$protocol_name = "lansource";
break;
case "1486":
	$protocol_name = "nms_topo_serv";
break;
case "1487":
	$protocol_name = "localinfosrvr";
break;
case "1488":
	$protocol_name = "docstor";
break;
case "1489":
	$protocol_name = "dmdocbroker";
break;
case "1490":
	$protocol_name = "insitu-conf";
break;
case "1491":
	$protocol_name = "anynetgateway";
break;
case "1492":
	$protocol_name = "stone-design-1";
break;
case "1493":
	$protocol_name = "netmap_lm";
break;
case "1494":
	$protocol_name = "citrix-ica";
break;
case "1495":
	$protocol_name = "cvc";
break;
case "1496":
	$protocol_name = "liberty-lm";
break;
case "1497":
	$protocol_name = "rfx-lm";
break;
case "1498":
	$protocol_name = "watcom-sql";
break;
case "1499":
	$protocol_name = "fhc";
break;
case "1500":
	$protocol_name = "vlsi-lm";
break;
case "1501":
	$protocol_name = "sas-3";
break;
case "1502":
	$protocol_name = "shivadiscovery";
break;
case "1503":
	$protocol_name = "imtc-mcs";
break;
case "1504":
	$protocol_name = "evb-elm";
break;
case "1505":
	$protocol_name = "funkproxy";
break;
case "1506":
	$protocol_name = "utcd";
break;
case "1507":
	$protocol_name = "symplex";
break;
case "1508":
	$protocol_name = "diagmond";
break;
case "1509":
	$protocol_name = "robcad-lm";
break;
case "1510":
	$protocol_name = "mvx-lm";
break;
case "1511":
	$protocol_name = "3l-l1";
break;
case "1512":
	$protocol_name = "wins";
break;
case "1513":
	$protocol_name = "fujitsu-dtc";
break;
case "1514":
	$protocol_name = "fujitsu-dtcns";
break;
case "1515":
	$protocol_name = "ifor-protocol";
break;
case "1516":
	$protocol_name = "vpad";
break;
case "1517":
	$protocol_name = "vpac";
break;
case "1518":
	$protocol_name = "vpvd";
break;
case "1519":
	$protocol_name = "vpvc";
break;
case "1520":
	$protocol_name = "atm-zip-office";
break;
case "1521":
	$protocol_name = "oracle";
break;
case "1522":
	$protocol_name = "rna-lm";
break;
case "1523":
	$protocol_name = "cichild-lm";
break;
case "1524":
	$protocol_name = "ingreslock";
break;
case "1525":
	$protocol_name = "orasrv";
break;
case "1526":
	$protocol_name = "pdap-np";
break;
case "1527":
	$protocol_name = "tlisrv";
break;
case "1528":
	$protocol_name = "mciautoreg";
break;
case "1529":
	$protocol_name = "support";
break;
case "1530":
	$protocol_name = "rap-service";
break;
case "1531":
	$protocol_name = "rap-listen";
break;
case "1532":
	$protocol_name = "miroconnect";
break;
case "1533":
	$protocol_name = "virtual-places";
break;
case "1534":
	$protocol_name = "micromuse-lm";
break;
case "1535":
	$protocol_name = "ampr-info";
break;
case "1536":
	$protocol_name = "ampr-inter";
break;
case "1537":
	$protocol_name = "sdsc-lm";
break;
case "1538":
	$protocol_name = "3ds-lm";
break;
case "1539":
	$protocol_name = "intellistor-lm";
break;
case "1540":
	$protocol_name = "rds";
break;
case "1541":
	$protocol_name = "rds2";
break;
case "1542":
	$protocol_name = "gridgen-elmd";
break;
case "1543":
	$protocol_name = "simba-cs";
break;
case "1544":
	$protocol_name = "aspeclmd";
break;
case "1545":
	$protocol_name = "vistium-share";
break;
case "1546":
	$protocol_name = "abbaccuray";
break;
case "1547":
	$protocol_name = "laplink";
break;
case "1548":
	$protocol_name = "axon-lm";
break;
case "1549":
	$protocol_name = "shivahose";
break;
case "1550":
	$protocol_name = "3m-image-lm";
break;
case "1551":
	$protocol_name = "hecmtl-db";
break;
case "1552":
	$protocol_name = "pciarray";
break;
case "1600":
	$protocol_name = "issd";
break;
case "1650":
	$protocol_name = "nkd";
break;
case "1651":
	$protocol_name = "shiva_confsrvr";
break;
case "1652":
	$protocol_name = "xnmp";
break;
case "1661":
	$protocol_name = "netview-aix-1";
break;
case "1662":
	$protocol_name = "netview-aix-2";
break;
case "1663":
	$protocol_name = "netview-aix-3";
break;
case "1664":
	$protocol_name = "netview-aix-4";
break;
case "1665":
	$protocol_name = "netview-aix-5";
break;
case "1666":
	$protocol_name = "netview-aix-6";
break;
case "1667":
	$protocol_name = "netview-aix-7";
break;
case "1668":
	$protocol_name = "netview-aix-8";
break;
case "1669":
	$protocol_name = "netview-aix-9";
break;
case "1670":
	$protocol_name = "netview-aix-10";
break;
case "1671":
	$protocol_name = "netview-aix-11";
break;
case "1672":
	$protocol_name = "netview-aix-12";
break;
case "1680":
	$protocol_name = "CarbonCopy";
break;
case "":
	$protocol_name = "H.323";
break;
case "1723":
	$protocol_name = "pptp";
break;
case "1755":
	$protocol_name = "wms";
break;
case "1827":
	$protocol_name = "pcm";
break;
case "1900":
	$protocol_name = "UPnP";
break;
case "1984":
	$protocol_name = "bigbrother";
break;
case "1986":
	$protocol_name = "licensedaemon";
break;
case "1987":
	$protocol_name = "tr-rsrb-p1";
break;
case "1988":
	$protocol_name = "tr-rsrb-p2";
break;
case "1989":
	$protocol_name = "tr-rsrb-p3";
break;
case "1990":
	$protocol_name = "stun-p1";
break;
case "1991":
	$protocol_name = "stun-p2";
break;
case "1992":
	$protocol_name = "stun-p3";
break;
case "1993":
	$protocol_name = "snmp-tcp-port";
break;
case "1994":
	$protocol_name = "stun-port";
break;
case "1995":
	$protocol_name = "perf-port";
break;
case "1996":
	$protocol_name = "tr-rsrb-port";
break;
case "1997":
	$protocol_name = "gdp-port";
break;
case "1998":
	$protocol_name = "x25-svc-port";
break;
case "1999":
	$protocol_name = "tcp-id-port";
break;
case "2000":
	$protocol_name = "callbook";
break;
case "2001":
	$protocol_name = "dc";
break;
case "2002":
	$protocol_name = "globe";
break;
case "2003":
	$protocol_name = "cfingerd";
break;
case "2004":
	$protocol_name = "mailbox";
break;
case "2005":
	$protocol_name = "deslogin";
break;
case "2006":
	$protocol_name = "invokator";
break;
case "2007":
	$protocol_name = "dectalk";
break;
case "2008":
	$protocol_name = "conf";
break;
case "2009":
	$protocol_name = "news";
break;
case "2010":
	$protocol_name = "search";
break;
case "2011":
	$protocol_name = "raid-cc";
break;
case "2012":
	$protocol_name = "ttyinfo";
break;
case "2013":
	$protocol_name = "raid-am";
break;
case "2014":
	$protocol_name = "troff";
break;
case "2015":
	$protocol_name = "cypress";
break;
case "2016":
	$protocol_name = "bootserver";
break;
case "2017":
	$protocol_name = "cypress-stat";
break;
case "2018":
	$protocol_name = "terminaldb";
break;
case "2019":
	$protocol_name = "whosockami";
break;
case "2020":
	$protocol_name = "xinupageserver";
break;
case "2021":
	$protocol_name = "servexec";
break;
case "2022":
	$protocol_name = "down";
break;
case "2023":
	$protocol_name = "xinuexpansion3";
break;
case "2024":
	$protocol_name = "xinuexpansion4";
break;
case "2025":
	$protocol_name = "ellpack";
break;
case "2026":
	$protocol_name = "scrabble";
break;
case "2027":
	$protocol_name = "shadowserver";
break;
case "2028":
	$protocol_name = "submitserver";
break;
case "2030":
	$protocol_name = "device2";
break;
case "2032":
	$protocol_name = "blackboard";
break;
case "2033":
	$protocol_name = "glogger";
break;
case "2034":
	$protocol_name = "scoremgr";
break;
case "2035":
	$protocol_name = "imsldoc";
break;
case "2038":
	$protocol_name = "objectmanager";
break;
case "2040":
	$protocol_name = "lam";
break;
case "2041":
	$protocol_name = "interbase";
break;
case "2042":
	$protocol_name = "isis";
break;
case "2043":
	$protocol_name = "isis-bcast";
break;
case "2044":
	$protocol_name = "rimsl";
break;
case "2045":
	$protocol_name = "cdfunc";
break;
case "2046":
	$protocol_name = "sdfunc";
break;
case "2047":
	$protocol_name = "dls";
break;
case "2048":
	$protocol_name = "dls-monitor";
break;
case "2049":
	$protocol_name = "nfs";
break;
case "2064":
	$protocol_name = "dnet-keyproxy";
break;
case "2053":
	$protocol_name = "knetd";
break;
case "2065":
	$protocol_name = "dlsrpn";
break;
case "2067":
	$protocol_name = "dlswpn";
break;
case "2068":
	$protocol_name = "advocentkvm";
break;
case "2105":
	$protocol_name = "eklogin";
break;
case "2106":
	$protocol_name = "ekshell";
break;
case "2108":
	$protocol_name = "rkinit";
break;
case "2111":
	$protocol_name = "kx";
break;
case "2112":
	$protocol_name = "kip";
break;
case "2120":
	$protocol_name = "kauth";
break;
case "2201":
	$protocol_name = "ats";
break;
case "2232":
	$protocol_name = "ivs-video";
break;
case "2241":
	$protocol_name = "ivsd";
break;
case "2301":
	$protocol_name = "compaqdiag";
break;
case "2307":
	$protocol_name = "pehelp";
break;
case "2401":
	$protocol_name = "cvspserver";
break;
case "2430":
	$protocol_name = "venus";
break;
case "2431":
	$protocol_name = "venus-se";
break;
case "2432":
	$protocol_name = "codasrv";
break;
case "2433":
	$protocol_name = "codasrv-se";
break;
case "2500":
	$protocol_name = "rtsserv";
break;
case "2501":
	$protocol_name = "rtsclient";
break;
case "2564":
	$protocol_name = "hp-3000-telnet";
break;
case "2600":
	$protocol_name = "zebrasrv";
break;
case "2601":
	$protocol_name = "zebra";
break;
case "2602":
	$protocol_name = "ripd";
break;
case "2603":
	$protocol_name = "ripngd";
break;
case "2604":
	$protocol_name = "ospfd";
break;
case "2605":
	$protocol_name = "bgpd";
break;
case "2627":
	$protocol_name = "webster";
break;
case "2638":
	$protocol_name = "sybase";
break;
case "2766":
	$protocol_name = "listen";
break;
case "2784":
	$protocol_name = "www-dev";
break;
case "2903":
	$protocol_name = "extensisportfolio";
break;
case "2998":
	$protocol_name = "iss-realsec";
break;
case "3000":
	$protocol_name = "ppp";
break;
case "3001":
	$protocol_name = "nessusd";
break;
case "3005":
	$protocol_name = "deslogin";
break;
case "3006":
	$protocol_name = "deslogind";
break;
case "3049":
	$protocol_name = "cfs";
break;
case "3052":
	$protocol_name = "PowerChute";
break;
case "3064":
	$protocol_name = "dnet-tstproxy";
break;
case "3086":
	$protocol_name = "sj3";
break;
case "3128":
	$protocol_name = "squid-http";
break;
case "3141":
	$protocol_name = "vmodem";
break;
case "3264":
	$protocol_name = "ccmail";
break;
case "3268":
	$protocol_name = "globalcatLDAP";
break;
case "3269":
	$protocol_name = "globalcatLDAPssl";
break;
case "3292":
	$protocol_name = "meetingmaker";
break;
case "3306":
	$protocol_name = "mysql";
break;
case "3333":
	$protocol_name = "dec-notes";
break;
case "3372":
	$protocol_name = "msdtc";
break;
case "3389":
	$protocol_name = "ms-term-serv";
break;
case "3421":
	$protocol_name = "bmap";
break;
case "3455":
	$protocol_name = "prsvp";
break;
case "3456":
	$protocol_name = "vat";
break;
case "3457":
	$protocol_name = "vat-control";
break;
case "3462":
	$protocol_name = "track";
break;
case "3689":
	$protocol_name = "rendezvous";
break;
case "3900":
	$protocol_name = "udt_os";
break;
case "3984":
	$protocol_name = "mapper-nodemgr";
break;
case "3985":
	$protocol_name = "mapper-mapethd";
break;
case "3986":
	$protocol_name = "mapper-ws_ethd";
break;
case "3999":
	$protocol_name = "remoteanything";
break;
case "4000":
	$protocol_name = "remoteanything";
break;
case "4008":
	$protocol_name = "netcheque";
break;
case "4045":
	$protocol_name = "lockd";
break;
case "4132":
	$protocol_name = "nuts_dem";
break;
case "4133":
	$protocol_name = "nuts_bootp";
break;
case "4144":
	$protocol_name = "wincim";
break;
case "4224":
	$protocol_name = "xtell";
break;
case "4321":
	$protocol_name = "rwhois";
break;
case "4333":
	$protocol_name = "msql";
break;
case "4343":
	$protocol_name = "unicall";
break;
case "4444":
	$protocol_name = "krb524";
break;
case "4480":
	$protocol_name = "proxy-plus";
break;
case "4500":
	$protocol_name = "sae-urn";
break;
case "4557":
	$protocol_name = "fax";
break;
case "4559":
	$protocol_name = "hylafax";
break;
case "4672":
	$protocol_name = "rfa";
break;
case "4899":
	$protocol_name = "radmin";
break;
case "4987":
	$protocol_name = "maybeveritas";
break;
case "4998":
	$protocol_name = "maybeveritas";
break;
case "5000":
	$protocol_name = "UPnP";
break;
case "5001":
	$protocol_name = "commplex-link";
break;
case "5002":
	$protocol_name = "rfe";
break;
case "5003":
	$protocol_name = "filemaker";
break;
case "5010":
	$protocol_name = "telelpathstart";
break;
case "5011":
	$protocol_name = "telelpathattack";
break;
case "5050":
	$protocol_name = "mmcc";
break;
case "5100":
	$protocol_name = "admd";
break;
case "5101":
	$protocol_name = "admdog";
break;
case "5102":
	$protocol_name = "admeng";
break;
case "5145":
	$protocol_name = "rmonitor_secure";
break;
case "5190":
	$protocol_name = "aol";
break;
case "5191":
	$protocol_name = "aol-1";
break;
case "5192":
	$protocol_name = "aol-2";
break;
case "5193":
	$protocol_name = "aol-3";
break;
case "5232":
	$protocol_name = "sgi-dgl";
break;
case "5236":
	$protocol_name = "padl2sim";
break;
case "5300":
	$protocol_name = "hacl-hb";
break;
case "5301":
	$protocol_name = "hacl-gs";
break;
case "5302":
	$protocol_name = "hacl-cfg";
break;
case "5303":
	$protocol_name = "hacl-probe";
break;
case "5304":
	$protocol_name = "hacl-local";
break;
case "5305":
	$protocol_name = "hacl-test";
break;
case "5308":
	$protocol_name = "cfengine";
break;
case "5400":
	$protocol_name = "pcduo-old";
break;
case "5405":
	$protocol_name = "pcduo";
break;
case "5490":
	$protocol_name = "connect-proxy";
break;
case "5432":
	$protocol_name = "postgres";
break;
case "5510":
	$protocol_name = "secureidprop";
break;
case "5520":
	$protocol_name = "sdlog";
break;
case "5530":
	$protocol_name = "sdserv";
break;
case "5540":
	$protocol_name = "sdreport";
break;
case "5550":
	$protocol_name = "sdadmind";
break;
case "5555":
	$protocol_name = "freeciv";
break;
case "5631":
	$protocol_name = "pcanywheredata";
break;
case "5632":
	$protocol_name = "pcanywherestat";
break;
case "5680":
	$protocol_name = "canna";
break;
case "5713":
	$protocol_name = "proshareaudio";
break;
case "5714":
	$protocol_name = "prosharevideo";
break;
case "5715":
	$protocol_name = "prosharedata";
break;
case "5716":
	$protocol_name = "prosharerequest";
break;
case "5717":
	$protocol_name = "prosharenotify";
break;
case "5800":
	$protocol_name = "vnc-http";
break;
case "5801":
	$protocol_name = "vnc-http-1";
break;
case "5802":
	$protocol_name = "vnc-http-2";
break;
case "5803":
	$protocol_name = "vnc-http-3";
break;
case "5900":
	$protocol_name = "vnc";
break;
case "5901":
	$protocol_name = "vnc-1";
break;
case "5902":
	$protocol_name = "vnc-2";
break;
case "5903":
	$protocol_name = "vnc-3";
break;
case "5977":
	$protocol_name = "ncd-pref-tcp";
break;
case "5978":
	$protocol_name = "ncd-diag-tcp";
break;
case "5979":
	$protocol_name = "ncd-conf-tcp";
break;
case "5997":
	$protocol_name = "ncd-pref";
break;
case "5998":
	$protocol_name = "ncd-diag";
break;
case "5999":
	$protocol_name = "ncd-conf";
break;
case "6000":
	$protocol_name = "X11";
break;
case "6001":
	$protocol_name = "X11:1";
break;
case "6002":
	$protocol_name = "X11:2";
break;
case "6003":
	$protocol_name = "X11:3";
break;
case "6004":
	$protocol_name = "X11:4";
break;
case "6005":
	$protocol_name = "X11:5";
break;
case "6006":
	$protocol_name = "X11:6";
break;
case "6007":
	$protocol_name = "X11:7";
break;
case "6008":
	$protocol_name = "X11:8";
break;
case "6009":
	$protocol_name = "X11:9";
break;
case "6050":
	$protocol_name = "arcserve";
break;
case "6101":
	$protocol_name = "VeritasBackupExec";
break;
case "6103":
	$protocol_name = "RETS-or-BackupExec";
break;
case "6105":
	$protocol_name = "isdninfo";
break;
case "6106":
	$protocol_name = "isdninfo";
break;
case "6110":
	$protocol_name = "softcm";
break;
case "6111":
	$protocol_name = "spc";
break;
case "6112":
	$protocol_name = "dtspc";
break;
case "6141":
	$protocol_name = "meta-corp";
break;
case "6142":
	$protocol_name = "aspentec-lm";
break;
case "6143":
	$protocol_name = "watershed-lm";
break;
case "6144":
	$protocol_name = "statsci1-lm";
break;
case "6145":
	$protocol_name = "statsci2-lm";
break;
case "6146":
	$protocol_name = "lonewolf-lm";
break;
case "6147":
	$protocol_name = "montage-lm";
break;
case "6148":
	$protocol_name = "ricardo-lm";
break;
case "6346":
	$protocol_name = "gnutella";
break;
case "6400":
	$protocol_name = "crystalreports";
break;
case "6401":
	$protocol_name = "crystalenterprise";
break;
case "6547":
	$protocol_name = "PowerChutePLUS";
break;
case "6548":
	$protocol_name = "PowerChutePLUS";
break;
case "6502":
	$protocol_name = "netop-rc";
break;
case "6558":
	$protocol_name = "xdsxdm";
break;
case "6588":
	$protocol_name = "analogx";
break;
case "6666":
	$protocol_name = "irc-serv";
break;
case "6667":
	$protocol_name = "irc";
break;
case "6668":
	$protocol_name = "irc";
break;
case "6969":
	$protocol_name = "acmsoda";
break;
case "6699":
	$protocol_name = "napster";
break;
case "7000":
	$protocol_name = "afs3-fileserver";
break;
case "7001":
	$protocol_name = "afs3-callback";
break;
case "7002":
	$protocol_name = "afs3-prserver";
break;
case "7003":
	$protocol_name = "afs3-vlserver";
break;
case "7004":
	$protocol_name = "afs3-kaserver";
break;
case "7005":
	$protocol_name = "afs3-volser";
break;
case "7006":
	$protocol_name = "afs3-errors";
break;
case "7007":
	$protocol_name = "afs3-bos";
break;
case "7008":
	$protocol_name = "afs3-update";
break;
case "7009":
	$protocol_name = "afs3-rmtsys";
break;
case "7010":
	$protocol_name = "ups-onlinet";
break;
case "7070":
	$protocol_name = "realserver";
break;
case "7100":
	$protocol_name = "font-service";
break;
case "7200":
	$protocol_name = "fodms";
break;
case "7201":
	$protocol_name = "dlip";
break;
case "7273":
	$protocol_name = "openmanage";
break;
case "7326":
	$protocol_name = "icb";
break;
case "7464":
	$protocol_name = "pythonds";
break;
case "7597":
	$protocol_name = "qaz";
break;
case "8000":
	$protocol_name = "http-alt";
break;
case "8007":
	$protocol_name = "ajp12";
break;
case "8009":
	$protocol_name = "ajp13";
break;
case "8080":
	$protocol_name = "http-proxy";
break;
case "8081":
	$protocol_name = "blackice-icecap";
break;
case "8082":
	$protocol_name = "blackice-alerts";
break;
case "8443":
	$protocol_name = "https-alt";
break;
case "8888":
	$protocol_name = "sun-answerbook";
break;
case "8892":
	$protocol_name = "seosload";
break;
case "9090":
	$protocol_name = "zeus-admin";
break;
case "9100":
	$protocol_name = "jetdirect";
break;
case "9111":
	$protocol_name = "DragonIDSConsole";
break;
case "9152":
	$protocol_name = "ms-sql2000";
break;
case "9535":
	$protocol_name = "man";
break;
case "9876":
	$protocol_name = "sd";
break;
case "9991":
	$protocol_name = "issa";
break;
case "9992":
	$protocol_name = "issc";
break;
case "9999":
	$protocol_name = "abyss";
break;
case "10000":
	$protocol_name = "snet-sensor-mgmt";
break;
case "10005":
	$protocol_name = "stel";
break;
case "10082":
	$protocol_name = "amandaidx";
break;
case "10083":
	$protocol_name = "amidxtape";
break;
case "11371":
	$protocol_name = "pksd";
break;
case "12000":
	$protocol_name = "cce4x";
break;
case "12345":
	$protocol_name = "NetBus";
break;
case "12346":
	$protocol_name = "NetBus";
break;
case "13701":
	$protocol_name = "VeritasNetbackup";
break;
case "13702":
	$protocol_name = "VeritasNetbackup";
break;
case "13705":
	$protocol_name = "VeritasNetbackup";
break;
case "13706":
	$protocol_name = "VeritasNetbackup";
break;
case "13708":
	$protocol_name = "VeritasNetbackup";
break;
case "13709":
	$protocol_name = "VeritasNetbackup";
break;
case "13710":
	$protocol_name = "VeritasNetbackup";
break;
case "13711":
	$protocol_name = "VeritasNetbackup";
break;
case "13712":
	$protocol_name = "VeritasNetbackup";
break;
case "13713":
	$protocol_name = "VeritasNetbackup";
break;
case "13714":
	$protocol_name = "VeritasNetbackup";
break;
case "13715":
	$protocol_name = "VeritasNetbackup";
break;
case "13716":
	$protocol_name = "VeritasNetbackup";
break;
case "13717":
	$protocol_name = "VeritasNetbackup";
break;
case "13718":
	$protocol_name = "VeritasNetbackup";
break;
case "13720":
	$protocol_name = "VeritasNetbackup";
break;
case "13721":
	$protocol_name = "VeritasNetbackup";
break;
case "13722":
	$protocol_name = "VeritasNetbackup";
break;
case "13782":
	$protocol_name = "VeritasNetbackup";
break;
case "13783":
	$protocol_name = "VeritasNetbackup";
break;
case "15126":
	$protocol_name = "swgps";
break;
case "16959":
	$protocol_name = "subseven";
break;
case "17007":
	$protocol_name = "isode-dua";
break;
case "17300":
	$protocol_name = "kuang2";
break;
case "18000":
	$protocol_name = "biimenu";
break;
case "18181":
	$protocol_name = "opsec_cvp";
break;
case "18182":
	$protocol_name = "opsec_ufp";
break;
case "18183":
	$protocol_name = "opsec_sam";
break;
case "18184":
	$protocol_name = "opsec_lea";
break;
case "18185":
	$protocol_name = "opsec_omi";
break;
case "18187":
	$protocol_name = "opsec_ela";
break;
case "20005":
	$protocol_name = "btx";
break;
case "22273":
	$protocol_name = "wnn6";
break;
case "22289":
	$protocol_name = "wnn6_Cn";
break;
case "22305":
	$protocol_name = "wnn6_Kr";
break;
case "22321":
	$protocol_name = "wnn6_Tw";
break;
case "22370":
	$protocol_name = "hpnpd";
break;
case "26208":
	$protocol_name = "wnn6_DS";
break;
case "27000":
	$protocol_name = "flexlm0";
break;
case "27001":
	$protocol_name = "flexlm1";
break;
case "27002":
	$protocol_name = "flexlm2";
break;
case "27003":
	$protocol_name = "flexlm3";
break;
case "27004":
	$protocol_name = "flexlm4";
break;
case "27005":
	$protocol_name = "flexlm5";
break;
case "27006":
	$protocol_name = "flexlm6";
break;
case "27007":
	$protocol_name = "flexlm7";
break;
case "27008":
	$protocol_name = "flexlm8";
break;
case "27009":
	$protocol_name = "flexlm9";
break;
case "27010":
	$protocol_name = "flexlm10";
break;
case "27374":
	$protocol_name = "subseven";
break;
case "27665":
	$protocol_name = "Trinoo_Master";
break;
case "31337":
	$protocol_name = "Elite";
break;
case "32770":
	$protocol_name = "sometimes-rpc3";
break;
case "32771":
	$protocol_name = "sometimes-rpc5";
break;
case "32772":
	$protocol_name = "sometimes-rpc7";
break;
case "32773":
	$protocol_name = "sometimes-rpc9";
break;
case "32774":
	$protocol_name = "sometimes-rpc11";
break;
case "32775":
	$protocol_name = "sometimes-rpc13";
break;
case "32776":
	$protocol_name = "sometimes-rpc15";
break;
case "32777":
	$protocol_name = "sometimes-rpc17";
break;
case "32778":
	$protocol_name = "sometimes-rpc19";
break;
case "32779":
	$protocol_name = "sometimes-rpc21";
break;
case "32780":
	$protocol_name = "sometimes-rpc23";
break;
case "32786":
	$protocol_name = "sometimes-rpc25";
break;
case "32787":
	$protocol_name = "sometimes-rpc27";
break;
case "43188":
	$protocol_name = "reachout";
break;
case "44334":
	$protocol_name = "tinyfw";
break;
case "44442":
	$protocol_name = "coldfusion-auth";
break;
case "44443":
	$protocol_name = "coldfusion-auth";
break;
case "47557":
	$protocol_name = "dbbrowse";
break;
case "49400":
	$protocol_name = "compaqdiag";
break;
case "54320":
	$protocol_name = "bo2k";
break;
case "61439":
	$protocol_name = "netprowler-manager";
break;
case "61440":
	$protocol_name = "netprowler-manager2";
break;
case "61441":
	$protocol_name = "netprowler-sensor";
break;
case "65301":
	$protocol_name = "pcanywhere";
break;
   default:
         $protocol_name = "unknown";
    break;

    }
    return $protocol_name;
}

?>
